from h5py import File
import numpy as np
from h5schemas.projection.add_projection import (
    init_projection_dataset,
    add_projection_sample,
)
from h5schemas.thd_joint_states.add_thd_joint_states import (
    init_thd_joint_states,
    add_thd_joint_states_sample,
)


def main():
    # Generate a file in write mode.
    test_file = File("./examples/projection.h5", "a")

    # Initialize the .H5 structure
    init_projection_dataset(test_file, False, (128, 128), (0.139, 0.139))

    # # Add joint states group
    # joint_states_group = test_file.require_group("/joint_states/")

    # Init joint states group
    init_thd_joint_states(test_file)

    # Add dummy projections 1
    add_projection_sample(
        test_file,
        1e5 * np.random.random((128, 128)),
        [0.0, 1.0, 2.0],
        [3.0, 4.0, 5.0, 6.0],
        [7.0, 8.0, 9.0],
        [10.0, 11.0, 12.0, 13],
    )
    add_thd_joint_states_sample(test_file, *np.arange(15))

    # # Add dummy projections 2
    # add_projection_sample(
    #     test_file,
    #     1e5 * np.random.random((128, 128)),
    #     np.array([0.0, 1.0, 2.0]),
    #     np.array([3.0, 4.0, 5.0, 6.0]),
    #     np.array([7.0, 8.0, 9.0]),
    #     np.array([10.0, 11.0, 12.0, 13]),
    #     voltage_kv=100,
    # )
    # add_thd_joint_states_sample(joint_states_group, *np.arange(15, 30))

    # # Access data
    # print(test_file["/image/image_array"][...])


if __name__ == "__main__":
    main()
